%mesh design

%problem 3(c)
%Mesh generation in square domain of ]0 1[

%Also Function handle is decleared in U

% The code calls L2Itpr for the mesh m and function U and computes L2 norm
% Interpolation error, exact solution and mesh dimension
close all
clear all;
clc;
U = @(x,y) sin((x.^2 + y.^2).^(0.5)); % Function Handle

% Mesh Generation
m = [];
L2err = zeros(1,5);
hmesh = zeros(1,5);
Labs = zeros(1,5);
m.Coordinates = [0 0;1 0;1 1;0 1];
m.Elements = [1 2 3; 1 4 3];
m = add_Edges(m);
m.BdFlags = [-1;0;-1;-1;-1];



%plot_Mesh(m);
%return

m = refine_REG(m);

%save_Mesh(m,'Coordinates_Mzero.dat','Elements_Mzero.dat');
%m = load_Mesh('Coordinates_Mzero.dat','Elements_Mzero.dat');


%return

%m = refine_REG(m);

%plot_Mesh(m); %Plotting mesh

%return

%End of mesh generation

for i = 1:5
 
plot_Mesh(m); %Plotting mesh
figure (i);

[L2err(1,i),Labs(1,i),hmesh(1,i)] = L2Itpr(m,U) % Call L2iperr for error computation and mesh size dimension

m = refine_REG(m); % Refine mesh

end;

figure (6);
loglog(hmesh,L2err); % Log Log plot of error vs hmesh